poj 2923 Relocation(状压dp)

题目链接

Relocation
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 2577   Accepted: 1052

Description

Emma and Eric are moving to their new house they bought after returning from their honeymoon. Fortunately, they have a few friends helping them relocate. To move the furniture, they only have two compact cars, which complicates everything a bit. Since the furniture does not fit into the cars, Eric wants to put them on top of the cars. However, both cars only support a certain weight on their roof, so they will have to do several trips to transport everything. The schedule for the move is planed like this:

  1. At their old place, they will put furniture on both cars.
  2. Then, they will drive to their new place with the two cars and carry the furniture upstairs.
  3. Finally, everybody will return to their old place and the process continues until everything is moved to the new place.

Note, that the group is always staying together so that they can have more fun and nobody feels lonely. Since the distance between the houses is quite large, Eric wants to make as few trips as possible.

Given the weights wi of each individual piece of furniture and the capacitiesC1 and C2 of the two cars, how many trips to the new house does the party have to make to move all the furniture? If a car has capacityC, the sum of the weights of all the furniture it loads for one trip can be at mostC.

Input

The first line contains the number of scenarios. Each scenario consists of one line containing three numbersn, C1 and C2. C1 andC2 are the capacities of the cars (1 ≤ Ci ≤ 100) andn is the number of pieces of furniture (1 ≤ n ≤ 10). The following line will containn integers w1, …, wn, the weights of the furniture (1 ≤wi ≤ 100). It is guaranteed that each piece of furniture can be loaded by at least one of the two cars.

Output

The output for every scenario begins with a line containing “Scenario #i:”, wherei is the number of the scenario starting at 1. Then print a single line with the number of trips to the new house they have to make to move all the furniture. Terminate each scenario with a blank line.

Sample Input

2
6 12 13
3 9 13 3 10 11
7 1 100
1 2 33 50 50 67 98

Sample Output

Scenario #1:
2

Scenario #2:
3

Source

TUD Programming Contest 2006, Darmstadt, Germany

题意:n个家具,体积为W1,W2......Wn。有两辆车容量为C1,C2。要把n个家具从一个地方,搬到另一个地方,每趟两辆车同时出发,问最少需要多少趟,把家具搬完?

题解:先预处理出一趟能搬的所有情况,用dp[i]表示把当前状态的物品运完最少需要多少趟(i的二进制状态表示当前剩余的物品),转移的时候枚举运哪些物品即可。

代码如下:

#include<stdio.h>
#include<iostream>
#include<algorithm>
#include<math.h>
#include<queue>
#include<stack>
#include<set>
#include<map>
#include<vector>
#include<string.h>
#include<string>
#include<stdlib.h>
typedef long long LL;
typedef unsigned long long LLU;
const int nn=20;
const int inf=0x3fffffff;
const LL inf64=(LL)inf*inf;
using namespace std;
int n,c1,c2;
int a[20];
int dp[(1<<10)+10];
bool ok[(1<<10)+10];
bool f[110];
void init()
{
    memset(ok,false,sizeof(ok));
    int i,j,k;
    int ix;
    for(i=1;i<(1<<n);i++)
    {
        for(j=1;j<=c1;j++)
        {
            f[j]=false;
        }
        f[0]=true;
        ix=0;
        for(j=0;j<n;j++)
        {
            if((1<<j)&i)
            {
                ix+=a[j];
                for(k=c1;k>=a[j];k--)
                {
                    f[k]=f[k-a[j]]?true:f[k];
                }
            }
        }
        for(j=c1;j>=0;j--)
        {
            if(f[j])
                break;
        }
        if(ix-j<=c2)
        {
            ok[i]=true;
        }
    }
}
int main()
{
    int t,cas=1;
    int i,j;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d%d",&n,&c1,&c2);
        for(i=0;i<n;i++)
        {
            scanf("%d",&a[i]);
        }
        init();
        dp[0]=0;
        for(i=1;i<(1<<n);i++)
        {
            dp[i]=inf;
            for(j=1;j<=i;j++)
            {
                if(ok[j])
                {
                    dp[i]=min(dp[i],dp[i^(i&j)]+1);
                }
            }
        }
        printf("Scenario #%d:\n",cas++);
        printf("%d\n\n",dp[(1<<n)-1]);
    }
    return 0;
}




猜你喜欢

转载自blog.csdn.net/madaidao/article/details/46050833